/*! \file utility.hpp
 *  \brief Definitions of the object 
 */
#ifndef UTILITY_H
#define UTILITY_H

#include <iostream>
#include <fstream>
#include <sstream>
#include<math.h>

namespace skelgis{

  //================================================================================
  //! header structure of the input binary file for DMatrix
  //-------------------------------------------------------------------------------
  struct HEADER
  //-------------------------------------------------------------------------------
  {
    unsigned int width;
    unsigned int height;
    float x;
    float y;
    float spacing;
    float nodata;
  };
  //-------------------------------------------------------------------------------

  //================================================================================
  //! header structure to read HEADER object
  //-------------------------------------------------------------------------------
  struct Header
  //-------------------------------------------------------------------------------
  {
    //! read method of Header
    /*!
      \param binFile is the path to the binary file to read
    */
    static HEADER read(const char * binFile)
    {
      HEADER head;
      std::ifstream f(binFile, std::ios::binary | std::ios::in);
      f.read(reinterpret_cast<char*>(&head),sizeof(HEADER));

      return head;
    }
  };
  //------------------------------------------------------------------------------
}

#endif
